MyGUI 3.2.2

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files
- Examples

- File List
- Globals

Namespaces | Macros
MyGUI_RTTI.h File Reference
`#include "MyGUI_Prerequest.h"`
`#include "MyGUI_Diagnostic.h"`
`#include <string>`
`#include <typeinfo>`

Go to the source code of this file.

## Namespaces
| MyGUI

## Macros
#define | MYGUI_RTTI_TYPE const std::type_info&
#define | MYGUI_RTTI_GET_TYPE(type) typeid(type)
#define | MYGUI_DECLARE_TYPE_NAME(Type)
#define | MYGUI_RTTI_BASE(BaseType)
#define | MYGUI_RTTI_DERIVED(DerivedType)

## Macro Definition Documentation

#define MYGUI_DECLARE_TYPE_NAME | ( |  | Type | ) |

Value:
public: \
static const std::string& getClassTypeName() { static std::string type = #Type; return type; } \ \
virtual const std::string& getTypeName() const { return getClassTypeName(); }

Definition at line 31 of file MyGUI_RTTI.h.

#define MYGUI_RTTI_BASE | ( |  | BaseType | ) |

Value:
public: \
typedef BaseType RTTIBase; \
MYGUI_DECLARE_TYPE_NAME(BaseType) \ \
virtual bool isType(MYGUI_RTTI_TYPE _type) const { return MYGUI_RTTI_GET_TYPE(BaseType) == _type; } \ \
template<typename Type> bool isType() const { return isType(MYGUI_RTTI_GET_TYPE(Type)); } \ \
template<typename Type> Type* castType(bool _throw = true) \
{ \
if (this->isType<Type>()) return static_cast<Type*>(this); \
MYGUI_ASSERT(!_throw, "Error cast type '" << this->getTypeName() << "' to type '" << Type::getClassTypeName() << "' .") \
return nullptr; \
} \ \
template<typename Type> const Type* castType(bool _throw = true) const \
{ \
if (this->isType<Type>()) return static_cast<Type*>(this); \
MYGUI_ASSERT(!_throw, "Error cast type '" << this->getTypeName() << "' to type '" << Type::getClassTypeName() << "' .") \
return nullptr; \
}
MYGUI_RTTI_GET_TYPE
#define MYGUI_RTTI_GET_TYPE(type)
Definition: MyGUI_RTTI.h:19
MYGUI_ASSERT
#define MYGUI_ASSERT(exp, dest)
Definition: MyGUI_Diagnostic.h:42
MYGUI_DECLARE_TYPE_NAME
#define MYGUI_DECLARE_TYPE_NAME(Type)
Definition: MyGUI_RTTI.h:31
MYGUI_RTTI_TYPE
#define MYGUI_RTTI_TYPE
Definition: MyGUI_RTTI.h:18

Definition at line 38 of file MyGUI_RTTI.h.

#define MYGUI_RTTI_DERIVED | ( |  | DerivedType | ) |

Value:
public: \
MYGUI_DECLARE_TYPE_NAME(DerivedType) \
typedef RTTIBase Base; \
typedef DerivedType RTTIBase; \ \
virtual bool isType(MYGUI_RTTI_TYPE _type) const { return MYGUI_RTTI_GET_TYPE(DerivedType) == _type || Base::isType(_type); } \ \
template<typename Type> bool isType() const { return isType(MYGUI_RTTI_GET_TYPE(Type)); }
MYGUI_RTTI_GET_TYPE
#define MYGUI_RTTI_GET_TYPE(type)
Definition: MyGUI_RTTI.h:19
MYGUI_DECLARE_TYPE_NAME
#define MYGUI_DECLARE_TYPE_NAME(Type)
Definition: MyGUI_RTTI.h:31
MYGUI_RTTI_TYPE
#define MYGUI_RTTI_TYPE
Definition: MyGUI_RTTI.h:18

Definition at line 65 of file MyGUI_RTTI.h.

#define MYGUI_RTTI_GET_TYPE | ( |  | type | ) | typeid(type)

Definition at line 19 of file MyGUI_RTTI.h.

#define MYGUI_RTTI_TYPE const std::type_info&

Definition at line 18 of file MyGUI_RTTI.h.